import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Spaceship here.
 * 
 * @author (Ahmad Nur) 
 * @version (a version number or a date)
 */ 
public class Spaceship extends Actor
{
    private int speed_, health, maxHealth;
    private boolean triggerReleased;
    private int reloadTimerL, reloadTimerF, reloadTimerM;
    private final int RELOADL = 10, RELOADF = 25, RELOADM = 50;
    private GreenfootImage thisImage;
    
    private boolean dmgTaken = false;
    private int dmgTakenTimer = 0;
    private final int MAX_TRANS = 255;
    

    
    public Spaceship() 
    {
        speed_ = 2;
        maxHealth = 5;
        health = maxHealth;
        triggerReleased = true;
        reloadTimerL = RELOADL;
        reloadTimerF = RELOADF;
        reloadTimerM = RELOADM;
    }
        
        
    public int getSpeed()
    {
        return speed_;
    }
   
    public void setSpeed(int s)
    {
        speed_ = s; 
    }
    
    public int getHealth()
    {
      return health;  
        
    }
    public void setHealth(int health)
    {
        
       this.health = health; 
        
    }
    
    public double getStatus()
    {
        return (double)health/maxHealth;
    }
    
    public void act()
    {
        processKeys();
        trackMouse();
        checkContact();
        processShot();
        reloadTimerL--;
        reloadTimerF--;
        reloadTimerM--;
    }
        
     
    public void processKeysAlt()
    {
    if(Greenfoot.isKeyDown("left"))
    {
    
        turn(-5);
    }
    else if (Greenfoot.isKeyDown("right"))
    {
        turn(5);
    }
    else if(Greenfoot.isKeyDown("up"))
    {
        if(speed_ <= 10)
        {
            speed_++;
        }
    }
    else if (Greenfoot.isKeyDown("down"))
    {
        if(speed_ > 0)
        {
            speed_--;
        }
    }
    move(speed_);
}
public void processKeys()
{
    if(Greenfoot.isKeyDown("a"))
    {
        setLocation(getX() -speed_, getY() );
    }
    else if (Greenfoot.isKeyDown("d"))
    {
        setLocation( getX() + speed_, getY() );
    }
    if (Greenfoot.isKeyDown("d"))
    {
        setLocation( getX() + speed_, getY() );
    }
    if (Greenfoot.isKeyDown("w"))
    {
        setLocation( getX(), getY() - speed_);
    }
    else if (Greenfoot.isKeyDown("s"))
    {
        setLocation( getX(), getY() + speed_ );
    }
    
  
}

 public void trackMouse()
 {
     MouseInfo mi = Greenfoot.getMouseInfo();
     if (mi != null)
     {
         turnTowards(mi.getX(), mi.getY());
        }
    }
  public void processShot()
  {
  
    if(Greenfoot.isKeyDown("space"))
    {
        shoot(new Bomb(5));
    }
    else if (Greenfoot.isKeyDown("f"))
    {
        shoot(new Fireball(2));
    }
    else if (Greenfoot.isKeyDown("e"))
    {
        shoot(new Nuclear(10));
    }
    else 
    {
        triggerReleased = true;
    }
}

  public void shoot(Weapons fireThis)
{
    
    fireThis.setRotation(getRotation());
    getWorld().addObject(fireThis,getX(), getY());
    fireThis.move(getImage().getWidth()/2);
}
 public void checkContact()
   {
        if(isTouching(Asteroid.class) && dmgTaken == false)
        
        {
        Asteroid asteroid = (Asteroid)getOneIntersectingObject(Asteroid.class);
        health -= asteroid.getDamage();
        dmgTaken = true;
        dmgTakenTimer = 50;
        changeTransparency(MAX_TRANS/2);
    }
        

    if (dmgTaken == true)
    {
        
     dmgTakenTimer--;
     if(dmgTakenTimer <= 0)
     {
         dmgTaken = false;
         changeTransparency(MAX_TRANS);
        
    }
}
        
    
    if (health <= 0)
    {
        Greenfoot.stop();
    }

}

public void changeTransparency(int transparency)
{
    GreenfootImage tempImage = getImage();
            tempImage.setTransparency(transparency);
        }
}



        
